
PlayerManaPercentConfig = {}
PlayerManaPercent = {}

local PlayerManaPercentAddon = CreateFrame("Frame", "PlayerManaPercentAddon", UIParent)

local DefaultConfig = {}
local RegisteredEvents = {}
PlayerManaPercentAddon:SetScript("OnEvent", function (self, event, ...) if (RegisteredEvents[event]) then return RegisteredEvents[event](self, event, ...) end end)

function RegisteredEvents:ADDON_LOADED(event, addon, ...)
	if (addon == "PlayerManaPercent") then
		SLASH_THP1 = '/pmp'
		SlashCmdList["PMP"] = function (msg, editbox)
			PlayerManaPercent.SlashCmdHandler(msg, editbox)	
		end
		setmetatable(PlayerManaPercentConfig, {__index = DefaultConfig})
		PlayerManaPercentUI.CreatepmpBar()
		PlayerManaPercentUI.CreateConfigMenu()
		print("PlayerManaPercent v5.1 Loaded. Type /pmp for usage")
	end
end

function RegisteredEvents:PLAYER_LOGIN(event)
	PlayerManaPercent.InitializeBar()
end

for k, v in pairs(RegisteredEvents) do
	PlayerManaPercentAddon:RegisterEvent(k)
end


function PlayerManaPercent.InitializeBar()

	--PlayerManaPercentBar:SetAlpha(PlayerManaPercent.GetConfigValue("barAlpha"))
	PlayerManaPercentBar:SetScale(PlayerManaPercent.GetConfigValue("barScale"))	
	
	PlayerManaPercent.ShowOrHideBar()
	
	--Consider these globals inside the addon, used to rate-limit OnUpdate script
	PlayerManaPercent.UPDATE_INTERVAL = 0.09
	PlayerManaPercent.TIME_SINCE_LAST_UPDATE = 0
	PlayerManaPercentAddon:SetScript("OnUpdate", PlayerManaPercent.OnUpdate)
		
	-- show config panel at load
	--InterfaceOptionsFrame_OpenToCategory("PlayerManaPercent")
	
	collectgarbage(collect)
	UpdateAddOnMemoryUsage()
end

function PlayerManaPercent.OnUpdate(self, elapsed)
	PlayerManaPercent.TIME_SINCE_LAST_UPDATE = PlayerManaPercent.TIME_SINCE_LAST_UPDATE + elapsed
	while (PlayerManaPercent.TIME_SINCE_LAST_UPDATE > PlayerManaPercent.UPDATE_INTERVAL) do
		PlayerManaPercent.UpdateBar()
		PlayerManaPercent.TIME_SINCE_LAST_UPDATE = PlayerManaPercent.TIME_SINCE_LAST_UPDATE - PlayerManaPercent.UPDATE_INTERVAL
	end
end

function PlayerManaPercent.UpdateBar()
	barDec = PlayerManaPercent.GetConfigValue("barDec")
	local  TargetsPercentOfMana = ( UnitPower("player",0) / UnitPowerMax("player",0) * 100)
	if UnitPowerMax("player",0) == 0 then
	TargetsPercentOfMana = 0
	end
	local text =""
	
	-- set decimal place
	if barDec == 0 then
		text = string.format("%.0f", TargetsPercentOfMana) .."%"
		pmpBar:SetSize(barWidth, 16)
		pmpBarBackground:SetSize(barWidth, 12)
		pmpBarText:SetSize(barWidth, 12.5) 
	elseif barDec == 1 then 
		text = string.format("%.1f", TargetsPercentOfMana) .."%"
		pmpBar:SetSize(barWidth+10, 16)
		pmpBarBackground:SetSize(barWidth +10 , 12)
		pmpBarText:SetSize(barWidth +10 , 12.5) 
	elseif barDec == 2 then
		text = string.format("%.2f", TargetsPercentOfMana) .."%"
		pmpBar:SetSize(barWidth+20, 16)
		pmpBarBackground:SetSize(barWidth +20 , 12)
		pmpBarText:SetSize(barWidth +20 , 12.5) 
	elseif barDec == 3 then
		text = string.format("%.3f", TargetsPercentOfMana) .."%"
		pmpBar:SetSize(barWidth+30, 16)
		pmpBarBackground:SetSize(barWidth +30 , 12)
		pmpBarText:SetSize(barWidth +30 , 12.5) 
	end
	
	-- handle color
	PlayerManaPercent.HandleBarColor(TargetsPercentOfMana)
	
	 
	
	PlayerManaPercentText:SetText(text);
	PlayerManaPercent.ShowOrHideBar();
end

function PlayerManaPercent.ShowOrHideBar()
	
	if PlayerManaPercent.GetConfigValue("locked") then
		PlayerManaPercent.SetLock(true)
	else
		PlayerManaPercent.SetLock(false)
	end

	if PlayerManaPercent.GetConfigValue("showAlways") then
	
		PlayerManaPercentBar:Show()
		return
	end
	
	if PlayerManaPercent.GetConfigValue("showTarget") and PlayerManaPercent.GetConfigValue("showCombat") then
		if UnitPowerMax("target",0) > 0 and UnitAffectingCombat("player")  then
			PlayerManaPercentBar:Show()
						
		else			
			PlayerManaPercentBar:Hide()
		end
		return
	end
	
	if PlayerManaPercent.GetConfigValue("showTarget") then
		if UnitManaMax("target") > 0   then
			PlayerManaPercentBar:Show()
			return			
		
		end
		--return
	end
	
	if PlayerManaPercent.GetConfigValue("showCombat") then
		if UnitAffectingCombat("player") then
			--print("I am in combat")
			PlayerManaPercentBar:Show()
			return
		else
			--print("I am not in combat")
			--PlayerManaPercentBar:Hide()
		end
	end
	PlayerManaPercentBar:Hide()
end

function PlayerManaPercent.SetLock(newValue)
	PlayerManaPercent.SetConfigValue("locked", newValue)
	if newValue then
	--	print("Target Mana Percent bar position locked")
	
	--pmpBar:SetSize(barWidth, 1) -- this makes the fram non interactive but the fram jumps., not sur ehow to fix it
	
	else
	--	print("Target Mana Percent bar position unlocked")
	--pmpBar:SetSize(barWidth, 16)
	
	
	end
end


function PlayerManaPercent.HandleBarColor(TargetsPercentOfMana)
	-- handle bg color change 
	local showColor35 = PlayerManaPercent.GetConfigValue("showColor35")
	local showColor25 = PlayerManaPercent.GetConfigValue("showColor25")
	local showUse20 = PlayerManaPercent.GetConfigValue("showUse20")
	
	--print ("showColor35 = " ..  tostring(showColor35) .. ", showColor25 = " ..  tostring(showColor25) )
	-- both are checked
	if showColor35 and showColor25 then
		
		
		if showUse20 then 
			if TargetsPercentOfMana >= 35 then
				-- black
				pmpBarBackground:SetTexture(0, 0, 0.5, PlayerManaPercent.GetConfigValue("barAlpha")) 
			elseif TargetsPercentOfMana < 35 and TargetsPercentOfMana > 20 then
				-- orange 
				pmpBarBackground:SetTexture(1, 0.6, 0.5, PlayerManaPercent.GetConfigValue("barAlpha")) 		
			elseif TargetsPercentOfMana < 20 and TargetsPercentOfMana > 0 then
				-- red
				pmpBarBackground:SetTexture(1, 0, 0.5, PlayerManaPercent.GetConfigValue("barAlpha")) 
			else
				-- black with no target
				pmpBarBackground:SetTexture(0, 0, 0.5, PlayerManaPercent.GetConfigValue("barAlpha"))
			end
			-- all done
			return
		else
			if TargetsPercentOfMana >= 35 then
				-- black
				pmpBarBackground:SetTexture(0, 0, 0.5, PlayerManaPercent.GetConfigValue("barAlpha")) 
			elseif TargetsPercentOfMana < 35 and TargetsPercentOfMana > 25 then
				-- orange 
				pmpBarBackground:SetTexture(1, 0.6, 0.5, PlayerManaPercent.GetConfigValue("barAlpha")) 		
			elseif TargetsPercentOfMana < 25 and TargetsPercentOfMana > 0 then
				-- red
				pmpBarBackground:SetTexture(1, 0, 0.5, PlayerManaPercent.GetConfigValue("barAlpha")) 
			else
				-- black with no target
				pmpBarBackground:SetTexture(0, 0, 0.5, PlayerManaPercent.GetConfigValue("barAlpha"))
			end
			-- all done
			return
		end
	end
	
	-- only 35 is checked
	if showColor35  then
		if TargetsPercentOfMana >= 35 then
			-- black
			pmpBarBackground:SetTexture(0, 0, 0.5, PlayerManaPercent.GetConfigValue("barAlpha")) 
		elseif TargetsPercentOfMana < 35 and TargetsPercentOfMana > 0 then
			-- orange 
			pmpBarBackground:SetTexture(1, 0.6, 0.5, PlayerManaPercent.GetConfigValue("barAlpha")) 		
		else
			-- black with no target
			pmpBarBackground:SetTexture(0, 0, 0.5, PlayerManaPercent.GetConfigValue("barAlpha"))
		end
		-- all done
		return
	end
	
		-- only 25 is checked
	if showColor25  then
	
		if showUse20 then 
			if TargetsPercentOfMana >= 20 then
				-- black
				pmpBarBackground:SetTexture(0, 0, 0.5, PlayerManaPercent.GetConfigValue("barAlpha")) 
			elseif TargetsPercentOfMana < 20 and TargetsPercentOfMana > 0 then
				-- red 
				pmpBarBackground:SetTexture(1, 0, 0.5, PlayerManaPercent.GetConfigValue("barAlpha")) 		
			else
				-- black with no target
				pmpBarBackground:SetTexture(0, 0, 0.5, PlayerManaPercent.GetConfigValue("barAlpha"))
			end
			-- all done
			return
		else
			if TargetsPercentOfMana >= 25 then
				-- black
				pmpBarBackground:SetTexture(0, 0, 0.5, PlayerManaPercent.GetConfigValue("barAlpha")) 
			elseif TargetsPercentOfMana < 25 and TargetsPercentOfMana > 0 then
				-- red 
				pmpBarBackground:SetTexture(1, 0, 0.5, PlayerManaPercent.GetConfigValue("barAlpha")) 		
			else
				-- black with no target
				pmpBarBackground:SetTexture(0, 0, 0.5, PlayerManaPercent.GetConfigValue("barAlpha"))
			end
			-- all done
			return
		end
	end
	
	-- nothing checked, turn black
	pmpBarBackground:SetTexture(0, 0, 0.5, PlayerManaPercent.GetConfigValue("barAlpha"))
	return
	
end

function PlayerManaPercent.SlashCmdHandler(msg, editbox)
	--print("command is " .. msg .. "\n")
	if (string.lower(msg) == "config") then
		InterfaceOptionsFrame_OpenToCategory("PlayerManaPercent")
	elseif (string.lower(msg) == "dumpconfig") then
		print("With defaults")
		for k,v in pairs(DefaultConfig) do
			print(k,PlayerManaPercent.GetConfigValue(k))
		end
		print("Direct table")
		for k,v in pairs(PlayerManaPercentConfig) do
			print(k,v)
		end
	elseif (string.lower(msg) == "lock") then
		PlayerManaPercent.SetLock(true)
	elseif (string.lower(msg) == "unlock") then
		PlayerManaPercent.SetLock(false)
	elseif (string.lower(msg) == "reset") then
		PlayerManaPercent.SetConfigToDefaults()
	elseif (string.lower(msg) == "perf") then
		PlayerManaPercent.PrintPerformanceData()
	else
		PlayerManaPercent.ShowHelp()
	end
end

function PlayerManaPercent.ShowHelp()
	print("Slash commands (/pmp):")
	print(" /pmp lock: Locks Target Mana Percent bar's position")
	print(" /pmp unlock: unLocks Target Mana Percent bar's position")
	print(" /pmp config: Open addon config menu (also found in Addon tab in Blizzard's Interface menu)")
	print(" /pmp reset:  Resets your config to defaults")
end

function PlayerManaPercent.PrintPerformanceData()
	UpdateAddOnMemoryUsage()
	local mem = GetAddOnMemoryUsage("PlayerManaPercent")
	print("PlayerManaPercent is currently using " .. mem .. " kbytes of memory")
	collectgarbage(collect)
	UpdateAddOnMemoryUsage()
	mem = GetAddOnMemoryUsage("PlayerManaPercent")
	print("PlayerManaPercent is currently using " .. mem .. " kbytes of memory after garbage collection")

end

function PlayerManaPercent.GetConfigValue(key)
	return PlayerManaPercentConfig[key]
end

function PlayerManaPercent.SetConfigValue(key, value)
	if (DefaultConfig[key] == value) then
		PlayerManaPercentConfig[key] = nil
	else 
		PlayerManaPercentConfig[key] = value
	end
end

function PlayerManaPercent.SetConfigToDefaults()
	print("Resetting config to defaults")
	PlayerManaPercentConfig = {}
	setmetatable(PlayerManaPercentConfig, {__index = DefaultConfig})

	PlayerManaPercentBar:ClearAllPoints()
	PlayerManaPercentBar:SetPoint('CENTER', UIParent)
	--PlayerManaPercentBar:SetAlpha(PlayerManaPercent.GetConfigValue("barAlpha"))
	PlayerManaPercentBar:SetScale(PlayerManaPercent.GetConfigValue("barScale"))

	PlayerManaPercent.ShowOrHideBar()
end

DefaultConfig = {
	showAlways = true,
	showTarget = true,
	showCombat = true,
	showColor35 = true,
	showColor25 = true,
	showUse20 = false,
	barText = "&hp",
	barAlpha = 1.0,
	barScale = 2.0,
	barDec = 0,
	locked = false
}
