
PlayerManaPercentUI = {}

function PlayerManaPercentUI.CreatepmpBar()
	barWidth = 38
	 pmpBar = CreateFrame("Frame", "PlayerManaPercentBar", UIParent)
	pmpBar:SetMovable(true)
	pmpBar:EnableMouse(true)
	pmpBar:SetSize(barWidth, 16) -- set to (100 ,1) for non interactive
	
	pmpBar:SetScript("OnMouseDown", 
		function (self, button)
			if button == "LeftButton" and not PlayerManaPercent.GetConfigValue("locked") then
				self:StartMoving();
			end
		end
	)
	
	pmpBar:SetScript("OnMouseUp", 
		function (self, button)
			if button == "LeftButton" then
				self:StopMovingOrSizing();
			end
		end
	)
	
	pmpBar:SetPoint("CENTER", 0, 0)
	pmpBar:Hide()
	pmpBarBackground = pmpBar:CreateTexture("PlayerManaPercentBarBackground", "BACKGROUND")
	pmpBarBackground:SetSize(barWidth , 12) -- background size
	pmpBarBackground:SetTexture(0, 0, 0, PlayerManaPercent.GetConfigValue("barAlpha")) -- how trasparent it is 0.0-1.0
	pmpBarBackground:SetPoint("TOP", 0, -2)

		-- not used
	--local pmpBarBorder = pmpBar:CreateTexture("PlayerManaPercentBarBorder", "OVERLAY")
	--pmpBarBorder:SetSize(111, 20)
	--pmpBarBorder:SetTexture("Interface\\Tooltips\\UI-StatusBar-Border")
	--pmpBarBorder:SetPoint("TOP", 0, 2)

	 pmpBarText = pmpBar:CreateFontString("PlayerManaPercentText", "OVERLAY", "GameFontHighlight")
	pmpBarText:SetSize(barWidth , 12.5) -- where text in realtion to bar
	pmpBarText:SetPoint("TOP", 0, -2)

	local pmpBarStatus = CreateFrame("StatusBar", "PlayerManaPercentStatusBar", pmpBar)
	pmpBarStatus:SetSize(barWidth , 10)
	pmpBarStatus:SetPoint("TOP", 0, -2)

	pmpBarStatus:SetFrameLevel(pmpBarStatus:GetParent():GetFrameLevel())


	local pmpBarStatusTexture = pmpBarStatus:CreateTexture("PlayerManaPercentStatusBarTexture", "BACKGROUND")
	

end


function PlayerManaPercentUI.CreateConfigMenu()
	local configPanel = CreateFrame("Frame", "PlayerManaPercentConfigFrame", UIParent)
	configPanel.name = "PlayerManaPercent"
	configPanel.okay = function (self) return end
	configPanel.cancel = function (self) return end

	local addonName, addonTitle, addonNotes = GetAddOnInfo('PlayerManaPercent')
	local configPanelText = configPanel:CreateFontString(nil, 'ARTWORK', 'GameFontNormalLarge')
	configPanelText:SetPoint('TOPLEFT', 16, -16)
	configPanelText:SetText(addonTitle)

	local configPanelDesc = configPanel:CreateFontString(nil, 'ARTWORK', 'GameFontHighlightSmall')
	--configPanelDesc:SetHeight(32)
	configPanelDesc:SetPoint('TOPLEFT', configPanelText, 'BOTTOMLEFT', 0, -8)
	configPanelDesc:SetPoint('RIGHT', configPanel, -32, 0)
	configPanelDesc:SetNonSpaceWrap(true)
	configPanelDesc:SetJustifyH('LEFT')
	configPanelDesc:SetJustifyV('TOP')
	configPanelDesc:SetText(addonNotes)
	
	local showLockDesc = configPanel:CreateFontString(nil, 'ARTWORK', 'GameFontNormal')
	showLockDesc:SetPoint('TOPLEFT', configPanelDesc, 'BOTTOMLEFT', -2, -10)
	showLockDesc:SetText("Locks or unlocks bar")

	local showLock = PlayerManaPercentUI.CreateCheckButton("Locked", configPanel,"Locked", "locked", 'InterfaceOptionsCheckButtonTemplate')
	showLock:SetPoint('TOPLEFT', showLockDesc, 'BOTTOMLEFT', 0, -5)

	local showOptionDesc = configPanel:CreateFontString(nil, 'ARTWORK', 'GameFontNormal')
	showOptionDesc:SetPoint('TOPLEFT', showLock, 'BOTTOMLEFT', -2, -10)
	showOptionDesc:SetText("When to show Bar")

	local showAlways = PlayerManaPercentUI.CreateCheckButton("Always", configPanel,"Always Show", "showAlways", 'InterfaceOptionsCheckButtonTemplate')
	showAlways:SetPoint('TOPLEFT', showOptionDesc, 'BOTTOMLEFT', 0, 0)

	local showTarget = PlayerManaPercentUI.CreateCheckButton("Have Target", configPanel,"Show bar only when you have some thing targeted ", "showTarget", 'InterfaceOptionsCheckButtonTemplate')
	showTarget:SetPoint('TOPLEFT', showAlways, 'BOTTOMLEFT', 10, 0)
	PlayerManaPercentUI.SetupInverseDependentControl(showAlways, showTarget)

	local showCombat = PlayerManaPercentUI.CreateCheckButton("In Combat", configPanel,"Show Bar while in combat", "showCombat", 'InterfaceOptionsCheckButtonTemplate')
	showCombat:SetPoint('TOPLEFT', showTarget, 'BOTTOMLEFT', 0, 0)
	PlayerManaPercentUI.SetupInverseDependentControl(showAlways, showCombat)


	local barAlphaDesc = configPanel:CreateFontString(nil, 'ARTWORK', 'GameFontNormal')
	barAlphaDesc:SetPoint('TOPLEFT', showCombat, 'BOTTOMLEFT', -10, -10)
	barAlphaDesc:SetText("Bar Alpha (Opacity): ")

	local barAlphaSlider = CreateFrame("Slider", configPanel:GetName() .. "BarAlphaSlider", configPanel, "OptionsSliderTemplate")
	barAlphaSlider:SetMinMaxValues(0.0, 1.0)
	barAlphaSlider:SetValueStep(0.01)
	barAlphaSlider:SetValue(PlayerManaPercent.GetConfigValue("barAlpha"))
	_G[barAlphaSlider:GetName() .. "High"]:SetText("1.0")
	_G[barAlphaSlider:GetName() .. "Low"]:SetText("0.0")
	barAlphaSlider:SetScript("OnValueChanged", PlayerManaPercentUI.BarAlphaSliderChanged)
	barAlphaSlider:SetPoint('TOPLEFT', barAlphaDesc, 'BOTTOMLEFT', 10, 0)

	local barScaleDesc = configPanel:CreateFontString(nil, 'ARTWORK', 'GameFontNormal')
	barScaleDesc:SetPoint('TOPLEFT', barAlphaSlider, 'BOTTOMLEFT', -10, -10)
	barScaleDesc:SetText("Bar Scale: ")

	local barScaleSlider = CreateFrame("Slider", configPanel:GetName() .. "barScaleSlider", configPanel, "OptionsSliderTemplate")
	barScaleSlider:SetMinMaxValues(.25, 3.0)
	barScaleSlider:SetValueStep(0.01)
	barScaleSlider:SetValue(PlayerManaPercent.GetConfigValue("barScale"))
	_G[barScaleSlider:GetName() .. "High"]:SetText("3.0")
	_G[barScaleSlider:GetName() .. "Low"]:SetText("0.25")
	barScaleSlider:SetScript("OnValueChanged", PlayerManaPercentUI.BarScaleSliderChanged)
	barScaleSlider:SetPoint('TOPLEFT', barScaleDesc, 'BOTTOMLEFT', 10, 0)
	
	local barDecDesc = configPanel:CreateFontString(nil, 'ARTWORK', 'GameFontNormal')
	barDecDesc:SetPoint('TOPLEFT', barScaleSlider, 'BOTTOMLEFT', -10, -10)
	barDecDesc:SetText("Number of places pass the decimal: ")

	local barDecSlider = CreateFrame("Slider", configPanel:GetName() .. "barDecSlider", configPanel, "OptionsSliderTemplate")
	barDecSlider:SetMinMaxValues(0, 3)
	barDecSlider:SetValueStep(1)
	barDecSlider:SetValue(PlayerManaPercent.GetConfigValue("barDec"))
	
	_G[barDecSlider:GetName() .. "High"]:SetText("3")
	_G[barDecSlider:GetName() .. "Low"]:SetText("0")
	barDecSlider:SetScript("OnValueChanged", PlayerManaPercentUI.BarDecSliderChanged)
	barDecSlider:SetPoint('TOPLEFT', barDecDesc, 'BOTTOMLEFT', 10, 0)
	
	local showColorDesc = configPanel:CreateFontString(nil, 'ARTWORK', 'GameFontNormal')
	showColorDesc:SetPoint('TOPLEFT', barDecSlider, 'BOTTOMLEFT', -10, -20)
	showColorDesc:SetText("Change the color of the bar when target gets below a set percent")

	local showColor35 = PlayerManaPercentUI.CreateCheckButton("Target below 35%", configPanel,"Change the color of the bar to orange when target gets below 35%", "showColor35", 'InterfaceOptionsCheckButtonTemplate')
	showColor35:SetPoint('TOPLEFT', showColorDesc, 'BOTTOMLEFT', 0, -5)
	
	local showColor25 = PlayerManaPercentUI.CreateCheckButton("Target below 25%", configPanel,"Change the color of the bar to red when target gets below 25%", "showColor25", 'InterfaceOptionsCheckButtonTemplate')
	showColor25:SetPoint('TOPLEFT', showColor35, 'BOTTOMLEFT', 0, -5)
	
	local showUse20 = PlayerManaPercentUI.CreateCheckButton("Use 20% instead of 25%", configPanel,"Change the percet at with the bar turn to red, makes it more use for 20% excute classes", "showUse20", 'InterfaceOptionsCheckButtonTemplate')
	showUse20:SetPoint('TOPLEFT', showColor25, 'BOTTOMLEFT', 200, 20)
	
	InterfaceOptions_AddCategory(configPanel)
end

function PlayerManaPercentUI.BarAlphaSliderChanged(self, value)
	PlayerManaPercent.SetConfigValue("barAlpha", value)
	pmpBarBackground:SetTexture(0, 0, 0, value)
end

function PlayerManaPercentUI.BarScaleSliderChanged(self, value)
	PlayerManaPercent.SetConfigValue("barScale", value)
	PlayerManaPercentBar:SetScale(value)
end

function PlayerManaPercentUI.BarDecSliderChanged(self, value)
	PlayerManaPercent.SetConfigValue("barDec", value)
	
end

function PlayerManaPercentUI.CreateCheckButton(name, parent, tooltipText, configKey, template)
	local button = CreateFrame('CheckButton', parent:GetName() .. name, parent, template)
	_G[button:GetName() .. 'Text']:SetText(name)
	button:SetChecked(PlayerManaPercent.GetConfigValue(configKey))
	button:SetScript('OnClick', function(self)
		if self:GetChecked() then
			PlayerManaPercent.SetConfigValue(configKey, true)
		else 
			PlayerManaPercent.SetConfigValue(configKey, false)
		end
		if ( self.dependentControls ) then
			if ( self:GetChecked() ) then
				for _, control in pairs(self.dependentControls) do
					control:Enable()
				end
			else
				for _, control in pairs(self.dependentControls) do
					control:Disable()
				end
			end
		end
		if ( self.inverseDependentControls ) then
			if ( self:GetChecked() ) then
				for _, control in pairs(self.inverseDependentControls) do
					control:Disable()
				end
			else
				for _, control in pairs(self.inverseDependentControls) do
					control:Enable()
				end
			end
		end
		PlayerManaPercent.ShowOrHideBar()

	end)
	button:SetScript('OnEnter', function(self)
		GameTooltip:SetOwner(self, "ANCHOR_RIGHT")
		GameTooltip:SetText(tooltipText, nil, nil, nil, 1, 1)
		GameTooltip:Show() end)
	button:SetScript('OnLeave', function(self) GameTooltip:Hide() end)

	return button
end

function PlayerManaPercentUI.SetupDependentControl (dependency, control)
	if ( not dependency ) then
		return
	end
	
	assert(control)
	
	dependency.dependentControls = dependency.dependentControls or {}
	tinsert(dependency.dependentControls, control)

	if ( control.type ~= CONTROLTYPE_DROPDOWN ) then
		control.Disable = function (self) getmetatable(self).__index.Disable(self) _G[self:GetName().."Text"]:SetTextColor(GRAY_FONT_COLOR.r, GRAY_FONT_COLOR.g, GRAY_FONT_COLOR.b) end
		control.Enable = function (self) getmetatable(self).__index.Enable(self) _G[self:GetName().."Text"]:SetTextColor(HIGHLIGHT_FONT_COLOR.r, HIGHLIGHT_FONT_COLOR.g, HIGHLIGHT_FONT_COLOR.b) end
		if dependency:GetChecked() then
			control:Enable()
		else
			control:Disable()
		end
	else
		control.Disable = function (self) UIDropDownMenu_DisableDropDown(self) end
		control.Enable = function (self) UIDropDownMenu_EnableDropDown(self) end
	end

end

function PlayerManaPercentUI.SetupInverseDependentControl (dependency, control)
	if ( not dependency ) then
		return
	end
	
	assert(control)
	
	dependency.inverseDependentControls = dependency.inverseDependentControls or {}
	tinsert(dependency.inverseDependentControls, control)

	if ( control.type ~= CONTROLTYPE_DROPDOWN ) then
		control.Disable = function (self) getmetatable(self).__index.Disable(self) _G[self:GetName().."Text"]:SetTextColor(GRAY_FONT_COLOR.r, GRAY_FONT_COLOR.g, GRAY_FONT_COLOR.b) end
		control.Enable = function (self) getmetatable(self).__index.Enable(self) _G[self:GetName().."Text"]:SetTextColor(HIGHLIGHT_FONT_COLOR.r, HIGHLIGHT_FONT_COLOR.g, HIGHLIGHT_FONT_COLOR.b) end
		if dependency:GetChecked() then
			control:Disable()
		else
			control:Enable()
		end
	else
		control.Disable = function (self) UIDropDownMenu_DisableDropDown(self) end
		control.Enable = function (self) UIDropDownMenu_EnableDropDown(self) end
	end

end